local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____isaac_2Dtypescript_2Ddefinitions = require("isaac-typescript-definitions")
local ModCallback = ____isaac_2Dtypescript_2Ddefinitions.ModCallback
local ____shouldFire = require("shouldFire")
local shouldFireFamiliar = ____shouldFire.shouldFireFamiliar
local ____DefaultMap = require("classes.DefaultMap")
local DefaultMap = ____DefaultMap.DefaultMap
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
local v = {run = {stateMap = __TS__New(
    DefaultMap,
    function(____, state) return state end
)}}
____exports.PostFamiliarStateChanged = __TS__Class()
local PostFamiliarStateChanged = ____exports.PostFamiliarStateChanged
PostFamiliarStateChanged.name = "PostFamiliarStateChanged"
__TS__ClassExtends(PostFamiliarStateChanged, CustomCallback)
function PostFamiliarStateChanged.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.v = v
    self.shouldFire = shouldFireFamiliar
    self.postFamiliarUpdate = function(____, familiar)
        local ptrHash = GetPtrHash(familiar)
        local previousState = v.run.stateMap:getAndSetDefault(ptrHash, familiar.State)
        local currentState = familiar.State
        v.run.stateMap:set(ptrHash, currentState)
        if previousState ~= currentState then
            self:fire(familiar, previousState, currentState)
        end
    end
    self.callbacksUsed = {{ModCallback.POST_FAMILIAR_UPDATE, self.postFamiliarUpdate}}
end
return ____exports
